#include "actorwidgetdata.h"

CActorWidgetData::CActorWidgetData() : CUMLWidgetData()
{
  m_Type = Uml::wt_Actor;
}

CActorWidgetData::~CActorWidgetData()
{
}

CActorWidgetData::CActorWidgetData(CActorWidgetData & Other) : CUMLWidgetData(Other)
{
	*this = Other;
}

CActorWidgetData & CActorWidgetData::operator=(CActorWidgetData & Other)
{
	*((CUMLWidgetData*)this) = (CUMLWidgetData)Other;

	return *this;
}

bool CActorWidgetData::operator==(CActorWidgetData & Other)
{
    if(!(*((CUMLWidgetData*)this) == (CUMLWidgetData)Other))
	{
		return false;
	}

	return true;
}

/** Returns the amount of bytes needed to serialize this object
If the serialization method of this class is changed this function will have to be CHANGED TOO
This function is used by the Copy and Paste Functionality
The Size in bytes of a serialized QString Object is long sz:
		if ( (sz =str.length()*sizeof(QChar)) && !(const char*)str.unicode() )
		{
			sz = size of Q_UINT32; //  typedef unsigned int	Q_UINT32;		// 32 bit unsigned
		}
	This calculation is valid only for QT 2.1.x or superior, this is totally incompatible with QT 2.0.x or QT 1.x or inferior
	That means the copy and paste functionality will work on with QT 2.1.x or superior */
long CActorWidgetData::getClipSizeOf()
{
	return CUMLWidgetData::getClipSizeOf();
}

/** No descriptions */
bool CActorWidgetData::serialize(QDataStream *s, bool archive)
{
	return CUMLWidgetData::serialize(s, archive);
}

bool CActorWidgetData::saveToXMI( QDomDocument & qDoc, QDomElement & qElement )
{
  QDomElement actorElement = qDoc.createElement( "UML:ActorWidget" );
  bool status = CUMLWidgetData::saveToXMI( qDoc, actorElement );
  qElement.appendChild( actorElement );
  return status;
}

bool CActorWidgetData::loadFromXMI( QDomElement & qElement )
{
  return CUMLWidgetData::loadFromXMI( qElement );
}



