#include <qglobal.h>
#include <qdatastream.h>

#include <kdebug.h>

#include "floatingtextdata.h"
#include "linepath.h"
#include "associationwidgetdata.h"

CAssociationWidgetData::CAssociationWidgetData( )
{
  m_nIndexA = m_nIndexB = 1;
  m_nTotalCountA = m_nTotalCountB = 2;
  m_pMultiDataB = 0;
  m_pMultiDataA = 0;
  m_pRoleData = 0;
  m_nWidgetAID = -1;
  m_nWidgetBID = -1;
  m_AssocType = Uml::at_Association;
}

CAssociationWidgetData::~CAssociationWidgetData()
{
}

CAssociationWidgetData::CAssociationWidgetData(CAssociationWidgetData & Other)
{
	*this = Other;
}

CAssociationWidgetData & CAssociationWidgetData::operator=(CAssociationWidgetData & Other)
{
  m_AssocType = Other.m_AssocType;
  m_LinePath = Other.m_LinePath ;
  m_nWidgetAID = Other.m_nWidgetAID;
  m_nWidgetBID = Other.m_nWidgetBID;
  m_nIndexA = Other.m_nIndexA;
  m_nIndexB = Other.m_nIndexB;
  m_nTotalCountA = Other.m_nTotalCountA;
  m_nTotalCountB = Other.m_nTotalCountB;
	
	m_pMultiDataA = new CFloatingTextData();
	if( Other.m_pMultiDataA )
		*(m_pMultiDataA) = *(Other.m_pMultiDataA);

	m_pMultiDataB = new CFloatingTextData();
	if( Other.m_pMultiDataB )
		*(m_pMultiDataB) = *(Other.m_pMultiDataB);
	
	m_pRoleData = new CFloatingTextData();
	if( Other.m_pRoleData )	
		*(m_pRoleData) = *(Other.m_pRoleData);
  return *this;
}

bool  CAssociationWidgetData::operator==(CAssociationWidgetData & Other)
{                              
	if( this == &Other ) 

		return true;                                           
	if( !m_pMultiDataA || !Other.m_pMultiDataA )
	{
		if( !Other.m_pMultiDataA && m_pMultiDataA ) 
			return false;                                                    
		if( !m_pMultiDataA && Other.m_pMultiDataA )  
			return false;                                                          
	}
	else if ( !(*m_pMultiDataA == *(Other.m_pMultiDataA)) ) 
		return false;

	if( !m_pMultiDataB || !Other.m_pMultiDataB )
	{
		if( !Other.m_pMultiDataB && m_pMultiDataB )
			return false;
		if( !m_pMultiDataB && Other.m_pMultiDataB )
			return false;
	}
	else if ( !(*m_pMultiDataB == *(Other.m_pMultiDataB)) )
		return false;

	if( !m_pRoleData || !Other.m_pRoleData )
	{
		if( !Other.m_pRoleData && m_pRoleData )
			return false;
		if( !m_pRoleData && Other.m_pRoleData )
			return false;
	}
	else if ( !(*m_pRoleData == *(Other.m_pRoleData)) )
		return false;
           
	if ( m_AssocType != Other.m_AssocType )
		return false;

	if(m_nWidgetAID != Other.m_nWidgetAID)
		return false;

	if(m_nWidgetBID != Other.m_nWidgetBID)
		return false;
	return true;
/*
	//Don't test these values - only graphic representation of association
		and if all the other values are the same then it's the same association.
         
	if( !(m_LinePath  == Other.m_LinePath)  )
    return false;

	  
  if(m_nIndexA != Other.m_nIndexA)
    return false;
  if(m_nIndexB != Other.m_nIndexB)
    return false;
  if(m_nTotalCountA != Other.m_nTotalCountA)
    return false;
  if(m_nTotalCountB != Other.m_nTotalCountB)
    return false;
*/	
}

CFloatingTextData* CAssociationWidgetData::getMultiDataA()
{
	return m_pMultiDataA;
}

void CAssociationWidgetData::setMultiDataA( CFloatingTextData* pData)
{
	m_pMultiDataA = pData;
}

CFloatingTextData* CAssociationWidgetData::getMultiDataB()
{
	return m_pMultiDataB;
}

void CAssociationWidgetData::setMultiDataB( CFloatingTextData* pData)
{
	m_pMultiDataB = pData;
}

CFloatingTextData* CAssociationWidgetData::getRoleData()
{
	return m_pRoleData;
}

void CAssociationWidgetData::setRoleData( CFloatingTextData* pData)
{
	m_pRoleData = pData;
}

Uml::Association_Type CAssociationWidgetData::getAssocType()
{
	return m_AssocType;
}

void CAssociationWidgetData::setAssocType( Uml::Association_Type Type)
{
  m_AssocType = Type;
  m_LinePath.setAssocType( Type );
}

bool CAssociationWidgetData::serialize(QDataStream *s, bool archive)
{
	if(archive)

	{
		QString str;
		if(m_pMultiDataA)
		{
			str =  "MULTI_A";
			*s << str;
       	if(!m_pMultiDataA->serialize(s, archive))
       	{
       		return false;
       	}
    	}
    	else
    	{
    		str =  "NO_MULTI_A";
			*s << str;
    	}
    	if(m_pMultiDataB)
    	{
			str =  "MULTI_B";
			*s << str;
        	if(!m_pMultiDataB->serialize(s, archive))
        	{
        		return false;

        	}

    	}
		else
    	{
    		str =  "NO_MULTI_B";
			*s << str;
    	}
    	if(m_pRoleData)
    	{
			str =  "ROLE";
			*s << str;
        	if(!m_pRoleData->serialize(s, archive))
        	{
        		return false;
        	}
    	}
		else
		{
			str =  "NO_ROLE";
			*s << str;
		}
		int i = static_cast<int>(m_AssocType);
		*s << (Q_INT32) i;
		*s << m_nWidgetAID;
		*s << m_nWidgetBID;
      *s << m_nIndexA << m_nIndexB;
      *s << m_nTotalCountA << m_nTotalCountB << m_Doc;
		m_LinePath.serialize( s, archive);
	}
	else //if (archive)
	{
		QString str;
		
		*s >> str;
		if(str == "MULTI_A")
		{
			m_pMultiDataA = new CFloatingTextData();

			if(!m_pMultiDataA->serialize(s, archive))
       	{
       		return false;
       	}
		}
		*s >> str;
		if(str == "MULTI_B")
		{
			m_pMultiDataB = new CFloatingTextData();
			if(!m_pMultiDataB->serialize(s, archive))
       	{
       		return false;
       	}

		}
		*s >> str;
		if(str == "ROLE")
		{
			m_pRoleData = new CFloatingTextData();
			if(!m_pRoleData->serialize(s, archive))
       	{
       		return false;
       	}
		}


		int i;
		*s >> i;


		m_AssocType = static_cast<Uml::Association_Type>(i);
		*s >> m_nWidgetAID;
		*s >> m_nWidgetBID;
      *s >> m_nIndexA >> m_nIndexB;
      *s >> m_nTotalCountA >> m_nTotalCountB >> m_Doc;
	m_LinePath.serialize( s, archive);
	}

	return true;
}

long CAssociationWidgetData::getClipSizeOf()
{
    long l_size = 0;
	QString str;
	Q_UINT32 tmp; //tmp is used to calculate the size of each serialized null string
	
	if(m_pMultiDataA)
	{
  		str = "MULTI_A";
		l_size += m_pMultiDataA->getClipSizeOf();
	}
	else
	{
		str = "NO_MULTI_A";
	}
	if ( !str.length() ) //We assume we are working with QT 2.1.x or superior, that means
																	//if unicode returns a null pointer then the serialization process of the QString object
																 	//will write a null marker 0xffffff, see QString::operator<< implementation
	{
		l_size += sizeof(tmp); 
	}
	else
	{
		l_size += (str.length()*sizeof(QChar));
	}
	if(m_pMultiDataB)
	{
		str = "MULTI_B";
		l_size += m_pMultiDataB->getClipSizeOf();
	}
	else
	{
		str = "NO_MULTI_B";
	}
	if ( !str.length() ) //We assume we are working with QT 2.1.x or superior, that means
																	//if unicode returns a null pointer then the serialization process of the QString object
																 	//will write a null marker 0xffffff, see QString::operator<< implementation
	{
		l_size += sizeof(tmp);
	}
	else
	{
		l_size += (str.length()*sizeof(QChar));
	}
	if(m_pRoleData)
	{
		str = "ROLE";

		l_size += m_pRoleData->getClipSizeOf();
	}
	else
	{
		str = "NO_ROLE";
	}
	if ( !str.length() ) //We assume we are working with QT 2.1.x or superior, that means
																	//if unicode returns a null pointer then the serialization process of the QString object
																 	//will write a null marker 0xffffff, see QString::operator<< implementation
	{
		l_size += sizeof(tmp);
	}
	else
	{
		l_size += (str.length()*sizeof(QChar));

	}
	if ( !m_Doc.length() ) 
	{
		l_size += sizeof(tmp);

	}
	else
	{
		l_size += (m_Doc.length()*sizeof(QChar));

	}
	
	l_size += sizeof(Q_INT32); //assoc type

  l_size += m_LinePath.getClipSizeOf();

  uint count = 0;
  Q_INT32 j =  0;
	l_size += ((count * 2 )* sizeof(j)); //Q_INT32 is the size of the X and Y members of each QPoint
																//This assuming we are working with a QDataStream version 	
																// greater than 1
	l_size += sizeof(m_nWidgetAID);
	l_size += sizeof(m_nWidgetBID);
   l_size += sizeof(m_nIndexA);
  l_size += sizeof(m_nIndexB);
  l_size += sizeof(m_nTotalCountA);
  l_size += sizeof(m_nTotalCountB);
	return l_size;
}

int CAssociationWidgetData::getWidgetAID()
{
	return m_nWidgetAID;
}

void CAssociationWidgetData::setWidgetAID( int AID)
{
	m_nWidgetAID = AID;
}

int CAssociationWidgetData::getWidgetBID()
{
	return m_nWidgetBID;
}

/** Write property of int m_nWidgetBID. */
void CAssociationWidgetData::setWidgetBID( int BID)
{
	m_nWidgetBID = BID;
}

void CAssociationWidgetData::print2cerr()
{
	QString str;
	switch(m_AssocType)
	{
      case Uml::at_Generalization:
			str = "GENERAL";
      break;
      case Uml::at_Aggregation:
			str = "AGGREG";
      break;
      case Uml::at_Dependency:
			str = "DEPENDENCY";

      break;
      case Uml::at_Association:
			str = "ASSOC";
      break;
      //case Uml::at_Message:
		//	str = "MESSAGE";
      break;
      case Uml::at_Implementation:
			str = "IMPLEMENTS";
      break;
      case Uml::at_Composition:

			str = "COMPOSITE";
      break;
      case Uml::at_UniAssociation:
			str = "UNIASSOC";
      break;
      case Uml::at_Realization:
			str = "REALIZE";
      break;
      case Uml::at_Anchor:
			str = "ANCHOR";
      break;
      default:
			str = "UNKNOWN TYPE";
      break;
	}
	kdDebug() << "m_AssocType = " << str <<endl;
	kdDebug() << "m_nWidgetAID = " << m_nWidgetAID << endl;
	kdDebug() << "m_nWidgetBID = " << m_nWidgetBID << endl;

	if(m_pMultiDataA)
	{
		kdDebug() << "m_pMultiDataA = {" << endl << endl;
		m_pMultiDataA->print2cerr();
		kdDebug() << "}" << endl;
	}
	else
	{
		 kdDebug() << "m_pMultiDataA = NULL" << endl;
	}
	if(m_pRoleData)
	{
		kdDebug() << "m_pRoleData = {" << endl << endl;
		m_pRoleData->print2cerr();
		kdDebug() << "}" << endl;
	}
	else
	{
		 kdDebug() << "m_pRoleData = NULL" << endl;
	}
	if(m_pMultiDataB)
	{
		kdDebug() << "m_pMultiDataB = {" << endl << endl;
		m_pMultiDataB->print2cerr();
		kdDebug() << "}" << endl;
	}
	else
	{

		 kdDebug() << "m_pMultiDataB = NULL" << endl;
	}
}

bool CAssociationWidgetData::saveToXMI( QDomDocument & qDoc, QDomElement & qElement )
{
  QDomElement assocElement = qDoc.createElement( "UML:AssocWidget" );
  bool status = true;

  if( m_pMultiDataA )
    status =  m_pMultiDataA -> saveToXMI( qDoc, assocElement );

  if( m_pMultiDataB )
    status = m_pMultiDataB -> saveToXMI( qDoc, assocElement );

  if( m_pRoleData )
    status = m_pRoleData -> saveToXMI( qDoc, assocElement );

  assocElement.setAttribute( "type", m_AssocType );
  assocElement.setAttribute( "indexa", m_nIndexA );
  assocElement.setAttribute( "indexb", m_nIndexB );
  assocElement.setAttribute( "totalcounta", m_nTotalCountA );
  assocElement.setAttribute( "totalcountb", m_nTotalCountB );
  assocElement.setAttribute( "widgetaid", m_nWidgetAID );
  assocElement.setAttribute( "widgetbid", m_nWidgetBID );
  assocElement.setAttribute( "documentation", m_Doc );
  m_LinePath.saveToXMI( qDoc, assocElement );
  qElement.appendChild( assocElement );
  return status;
}

bool CAssociationWidgetData::loadFromXMI( QDomElement & qElement )
{

  m_Doc = qElement.attribute( "documentation", "" );
  QString indexa = qElement.attribute( "indexa", "0" );
  QString indexb = qElement.attribute( "indexb", "0" );
  QString totalcounta = qElement.attribute( "totalcounta", "0" );
  QString totalcountb = qElement.attribute( "totalcountb", "0" );
  QString widgetaid = qElement.attribute( "widgetaid", "-1" );
  QString widgetbid = qElement.attribute( "widgetbid", "-1" );
  QString type = qElement.attribute( "type", "" );

  m_nIndexA = indexa.toInt();
  m_nIndexB = indexb.toInt();
  m_nTotalCountA = totalcounta.toInt();
  m_nTotalCountB = totalcountb.toInt();
  m_nWidgetAID = widgetaid.toInt();
  m_nWidgetBID = widgetbid.toInt();
  if( type != "" )
    m_AssocType = (Uml::Association_Type)type.toInt();

  //now load child elements
  QDomNode node = qElement.firstChild();
  QDomElement element = node.toElement();
  while( !element.isNull() )
  {
    QString tag = element.tagName();
    if( tag == "linepath" )
    {
      if( !m_LinePath.loadFromXMI( element ) )
        return false;
    }
    else if( tag == "UML:FloatingTextWidget" )
    {
      QString r = element.attribute( "role", "-1");
      if( r == "-1" )
        return false;
      Uml::Text_Role role = (Uml::Text_Role)r.toInt();
      switch( role )
      {
        case Uml::tr_MultiA:
          m_pMultiDataA = new CFloatingTextData();
          if( !m_pMultiDataA -> loadFromXMI( element ) )
            return false;
        break;

        case Uml::tr_MultiB:
          m_pMultiDataB = new CFloatingTextData();
          if( !m_pMultiDataB -> loadFromXMI( element ) )
            return false;
        break;

        case Uml::tr_RoleName:
        case Uml::tr_Coll_Message:
          m_pRoleData = new CFloatingTextData();
          if( !m_pRoleData -> loadFromXMI( element ) )
            return false;
        break;
				default:
				break;
      }
    }
    node = element.nextSibling();
    element = node.toElement();
  }
  return true;
}

void CAssociationWidgetData::cleanup()
{
  m_LinePath.cleanup();
}






