#ifndef CCLASSIMPORT_H
#define CCLASSIMPORT_H

// include files for Qt
#include <qdir.h>
#include <qwidget.h>
#include <qclipboard.h>
#include <qobjcoll.h>

// include files for KDE
#include <klocale.h>
#include <kmessagebox.h>
#include "klineeditdlg.h"
#include <kio/job.h>
#include <kio/netaccess.h>

// application specific includes
#include "umldoc.h"
#include "uml.h"
#include "umlview.h"
#include "concept.h"
#include "usecase.h"
#include "actor.h"
#include "mylistview.h"
#include "uml.h"
#include "worktoolbar.h"
#include "operation.h"
#include "attribute.h"
#include "dialogs/classpropdlg.h"
#include "objectwidget.h"
#include "umlwidget.h"

#include "classparser/ClassParser.h"


/**interfaces classparser library to uml models
  *@author Mikko Pasanen
  */

class CClassImport : private UMLDoc {
public:
	void importCPP(QStringList headerFiles);
	CClassImport(QWidget *parent, const char *name);
	~CClassImport();
  /** No descriptions */
  UMLObject *createUMLObject(QString className, Uml::UMLObject_Type type);
  /** No descriptions */
  void insertAttribute(UMLObject *o, Uml::Scope scope, QString name, QString type, QString value = "");
  /** No descriptions */
  void insertMethod(UMLObject *o, Uml::Scope scope, QString name, QString type, QList<UMLAttribute> *parList = NULL);
  /** No descriptions */
  bool createClass(QString className, UMLObject *uObject);
};

#endif
