#ifndef ACTIVITYPAGE_H
#define ACTIVITYPAGE_H
//qt includes
#include <qwidget.h>
#include <qgroupbox.h>
#include <qlistbox.h>
//kde includes
#include <karrowbutton.h>
//app includes

class StateWidget;
class ListPopupMenu;
/**
*		@author Paul Hensgen
*/

class ActivityPage : public QWidget  
{
Q_OBJECT
public: 
	/**
	*		Constructor
	*/
	ActivityPage( QWidget * pParent, StateWidget * pWidget );

	/**
	*		Deconstructor
	*/
	~ActivityPage();

	/**
	*		Sets up the page.
	*/
	void setupPage();

	/**
	*		Sets the activities of the widget.
	*/
	void updateActivities();

protected:
	/**
		*	Set the state of the widgets on the page with the given value.
		*
		*	@param	state	The state to set the widgets as.
		*/
	void enableWidgets(bool state);

	/**
	*		The widget to get the activities from.
	*/
	StateWidget * m_pStateWidget;

	/**
	*		Popup menu used.
	*/
	ListPopupMenu * m_pMenu;
	//GUI widgets
	QListBox * m_pActivityLB;
	QGroupBox * m_pActivityGB;
	KArrowButton * m_pUpArrowB, * m_pDownArrowB;
public slots:
	/**
	*		Popup menu item selected
	*/
	void slotMenuSelection( int sel );
	void slotClicked( QListBoxItem *item );
	void slotRightButtonClicked(QListBoxItem * item, const QPoint & p);
	void slotRightButtonPressed(QListBoxItem * item, const QPoint & p);
	void slotUpClicked();
	void slotDownClicked();
};

#endif
