/***************************************************************************
                          codegenerationoptionspage.cpp  -  description
                             -------------------
    begin                : Thu Jul 25 2002
    copyright            : (C) 2002 by Luis De la Parra
    email                : luis@delaparra.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "codegenerationoptionspage.h"

//kde include
#include <kfiledialog.h>
#include <klocale.h>
#include <kdebug.h>
//qt include
#include <qlineedit.h>
#include <qbuttongroup.h>

//app includes




CodeGenerationOptionsPage::CodeGenerationOptionsPage(const SettingsDlg::CodeGenState &state, QWidget *parent, const char *name )
                          :CodeGenerationOptionsBase(parent,name)
{
  setState(state);
}

CodeGenerationOptionsPage::~CodeGenerationOptionsPage()

{

}

void CodeGenerationOptionsPage::setState(const SettingsDlg::CodeGenState &state)
{
  m_forceDoc->setChecked(state.forceDoc);
  m_forceSections->setChecked(state.forceSections);
  m_outputDir->setText(state.outputDir);
  m_includeHeadings->setChecked(state.includeHeadings);
  m_headingsDir->setText(state.headingsDir);
  m_overwriteGroup->setButton(state.overwritePolicy); //0 = overwrite, 1 = ask, 2 = change name

}

void CodeGenerationOptionsPage::state(SettingsDlg::CodeGenState &state)
{
  state.forceDoc = m_forceDoc->isChecked();
  state.forceSections = m_forceSections->isChecked();
  state.outputDir = m_outputDir->text();
  state.includeHeadings = m_includeHeadings->isChecked();
  state.headingsDir = m_headingsDir->text();
  state.overwritePolicy = (CodeGenerator::OverwritePolicy)m_overwriteGroup->id(m_overwriteGroup->selected());

}

void CodeGenerationOptionsPage::setDefaults()
{

}

void CodeGenerationOptionsPage::browseClicked()
{
 QString button = sender()->name();
 QString dir = KFileDialog::getExistingDirectory();
 if(dir.isEmpty()) return;
 if(button=="m_browseOutput")
    m_outputDir->setText(dir);
 else if(button=="m_browseHeadings")
    m_headingsDir->setText(dir);

}

