#ifndef UMLATTRIBUTEDIALOG_H
#define UMLATTRIBUTEDIALOG_H

//kde includes
#include <kdialogbase.h>
//qt includes
#include <qgroupbox.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qlineedit.h>
//app includes

/**
  *@author Paul Hensgen
  */

class UMLAttribute;

class UMLAttributeDialog : public KDialogBase
{
Q_OBJECT
public:
	UMLAttributeDialog( QWidget * pParent, UMLAttribute * pAttribute );
	~UMLAttributeDialog();

protected:
	/**
	*		Sets up the dialog
	*/
        void setupDialog();

        /**
         * Checks if changes are valid and applies them if they are,
         * else returns false
         */
	bool apply();

	/**
	*		The Attribute to represent
	*/
	UMLAttribute * m_pAttribute;

	//GUI Widgets
	QGroupBox * m_pAttsGB, * m_pValuesGB;
	QButtonGroup * m_pScopeBG;
	QRadioButton * m_pPublicRB, * m_pPrivateRB,  * m_pProtectedRB;
	QLabel * m_pTypeL, * m_pNameL, * m_pInitialL;
	QComboBox * m_pTypeCB;
	QLineEdit * m_pNameLE, * m_pInitialLE;

public slots:
    /**
     * I don't think this is used, but if we had an apply button
     * it would slot into here
     */
    void slotApply();
    /**
     * Used when the OK button is clicked.  Calls apply()
     */
    void slotOk();
};

#endif
