#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <kconfig.h>
#include <klocale.h>
#include <unistd.h>
#include <ktip.h>

#include "uml.h"
#include "kstartuplogo.h"

static const char *description =
	I18N_NOOP("UML");
// INSERT A DESCRIPTION FOR YOUR APPLICATION HERE


static KCmdLineOptions options[] =
{
  { "+[File]", I18N_NOOP("file to open"), 0 },
  { 0, 0, 0 }
  // INSERT YOUR COMMANDLINE OPTIONS HERE
};

int main(int argc, char *argv[])
{

	KAboutData aboutData( "uml", I18N_NOOP("UML"),
		VERSION, description, KAboutData::License_GPL,
		"(c) 2001, Paul Hensgen", 0, 0, "phensgen@users.sourceforge.net");
	aboutData.addAuthor("Paul Hensgen",0, "phensgen@users.sourceforge.net");
	KCmdLineArgs::init( argc, argv, &aboutData );
	KCmdLineArgs::addCmdLineOptions( options ); // Add our own options.

	KApplication app;
	if( app.isRestored() )
	{
		RESTORE( UMLApp );
	}
	else
	{
		KStartupLogo* start_logo = 0L;
		UMLApp *uml = new UMLApp();
		KConfig * cfg = app.config();
		//see if we want a logo shown
		cfg -> setGroup( "General Options" );
		bool showLogo = cfg -> readBoolEntry( "logo", true );
		if( showLogo )
		{
			start_logo = new KStartupLogo();
			start_logo -> setHideEnabled( true );
			start_logo->show();
			start_logo->raise();
			QApplication::flushX();
			sleep(2);
			delete start_logo;
		}
		uml -> show();
		//show tips if wanted
                KTipDialog::showTip();

		KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
		if ( args -> count() )
		{
				uml -> openDocumentFile( args -> url( 0 ) );
				args -> clear();
		}
		else
		{
			cfg -> setGroup( "General Options" );
			bool last = cfg -> readBoolEntry( "loadlast", false );
			QString file = cfg -> readEntry( "lastFile", "" );
			if( last && file != "" )
				uml->openDocumentFile( KURL( file ) );
		}
	}
	return app.exec();
}
