#ifndef NOTEWIDGETDATA_H
#define NOTEWIDGETDATA_H

#include <qstring.h>
#include "umlwidgetdata.h"

class QDataStream;

/**	This class holds all the NoteWidget's Information
*		All this information goes to a file or clipboard
*		when an NoteWidget object is serialized
*		With this class we are trying to achieve isolation
*		between data and display layers.
*		@author Gustavo Madrigal
*/

class CNoteWidgetData : public CUMLWidgetData
{
friend class NoteWidget;
public: 
	/**
	*
	*/
	CNoteWidgetData();

	/**
	*
	*/
	CNoteWidgetData(CNoteWidgetData & Other);

	/**
	*
	*/
	~CNoteWidgetData();

	/**
	*
	*/
	virtual CNoteWidgetData & operator=(CNoteWidgetData & Other);

	/**
	*
	*/
	virtual bool operator==(CNoteWidgetData & Other);

  /** 
	*	Write property of QString m_Text. 
	*/
  virtual void setText( QString Text);

  /**
	*	Read property of QString m_Text. 
	*/
  virtual QString getText();

  /**
	*	Returns the amount of bytes needed to serialize this object 
	*/
  virtual long getClipSizeOf();

  /**
	*	Write property of bool m_bLinkDocumentation. 
	*/
  virtual void setLinkDocumentation( bool LinkDocumentation);

  /**
	*	Read property of bool m_bLinkDocumentation. 
	*/
  virtual bool getLinkDocumentation();
	
  /**
	*	No descriptions 
	*/
  virtual bool serialize(QDataStream *s, bool archive);

	/**
	*
	*/
  bool saveToXMI( QDomDocument & qDoc, QDomElement & qElement );

	/**
	*
	*/
  bool loadFromXMI( QDomElement & qElement );
protected: // Protected attributes
  /**
	*  
	*/
  QString m_Text;

  /**
	*  
	*/
  bool m_bLinkDocumentation;
};

#endif
