#include "usecasewidget.h"
#include "usecasewidgetdata.h"
#include "umlwidget.h"
#include "umlview.h"

UseCaseWidget::UseCaseWidget(UMLView * view, UMLObject *o, CUMLWidgetData* pData) : UMLWidget(view, o, pData)
{	  
}

UseCaseWidget::UseCaseWidget(UMLView * view, UMLObject *o) : UMLWidget(view, o, new CUseCaseWidgetData())
{    
	m_pData->setType(wt_UseCase);
	calculateSize();
}
////////////////////////////////////////////////////////////////////////////////////////////////////
UseCaseWidget::UseCaseWidget(UMLView * view) : UMLWidget(view, new CUseCaseWidgetData())
{    
	m_pData->setType(wt_UseCase);
	calculateSize();
}
////////////////////////////////////////////////////////////////////////////////////////////////////
UseCaseWidget::~UseCaseWidget()
{
}
////////////////////////////////////////////////////////////////////////////////////////////////////
void UseCaseWidget::draw(QPainter & p, int offsetX, int offsetY)
{
	p.setPen(m_LineColor);
	if(m_pData->getUseFillColor())
		p.setBrush(m_FillColor);
  	p.setFont( m_pData -> getFont() );
	QFontMetrics fm = QFontMetrics( m_pData -> getFont() );
	int fontHeight  = fm.lineSpacing();
	int w = width();
    int h = height();
	//int middleX = w / 2;
	int textStartY = (h / 2) - (fontHeight / 2);

	p.drawEllipse(offsetX, offsetY, w, h);
	p.setPen(black);
	p.drawText(offsetX + UC_MARGIN, offsetY + textStartY, w - UC_MARGIN * 2, fontHeight, AlignCenter, GetName());
	p.setPen(m_LineColor);
	if(m_bSelected)
		drawSelected(&p, offsetX, offsetY);




}
////////////////////////////////////////////////////////////////////////////////////////////////////
void UseCaseWidget::calculateSize()

{
	QFontMetrics fm = QFontMetrics( m_pData -> getFont() );
	int fontHeight  = fm.lineSpacing();
	int textWidth = fm.width(GetName());
	int width = textWidth > UC_WIDTH?textWidth:UC_WIDTH;
	int height = UC_HEIGHT + fontHeight + UC_MARGIN;

	width += UC_MARGIN * 2;
	setSize(width, height);
}

void UseCaseWidget::SynchronizeData()
{

	//Nothing to synchronize
	UMLWidget::SynchronizeData();
}
