#include <qdatastream.h>

#include "usecasewidgetdata.h"

CUseCaseWidgetData::CUseCaseWidgetData()
{
  m_Type = Uml::wt_UseCase;
}

CUseCaseWidgetData::CUseCaseWidgetData(CUseCaseWidgetData & Other) : CUMLWidgetData(Other)
{
     *this = Other;
}

CUseCaseWidgetData::~CUseCaseWidgetData()
{

}

CUseCaseWidgetData & CUseCaseWidgetData::operator=(CUseCaseWidgetData & Other)
{
	*((CUMLWidgetData*)this) = (CUMLWidgetData)Other;

	return *this;
}

bool CUseCaseWidgetData::operator==(CUseCaseWidgetData & Other)
{
    if(!(*((CUMLWidgetData*)this) == (CUMLWidgetData)Other))
	{
		return false;
	}

	return true;
}

/** Returns the amount of bytes needed to serialize this object 
If the serialization method of this class is changed this function will have to be CHANGED TOO
This function is used by the Copy and Paste Functionality
The Size in bytes of a serialized QString Object is long sz:
		if ( (sz =str.length()*sizeof(QChar)) && !(const char*)str.unicode() )
		{
			sz = size of Q_UINT32; //  typedef unsigned int	Q_UINT32;		// 32 bit unsigned
		}
	This calculation is valid only for QT 2.1.x or superior, this is totally incompatible with QT 2.0.x or QT 1.x or inferior
	That means the copy and paste functionality will work on with QT 2.1.x or superior */
long CUseCaseWidgetData::getClipSizeOf()
{
	return CUMLWidgetData::getClipSizeOf();
}

/** No descriptions */
bool CUseCaseWidgetData::serialize(QDataStream *s, bool archive)
{
	return CUMLWidgetData::serialize(s, archive);
}

bool CUseCaseWidgetData::saveToXMI( QDomDocument & qDoc, QDomElement & qElement )
{
  QDomElement usecaseElement = qDoc.createElement( "UML:UseCaseWidget" );
  bool status = CUMLWidgetData::saveToXMI( qDoc, usecaseElement );
  qElement.appendChild( usecaseElement );
  return status;
}

bool CUseCaseWidgetData::loadFromXMI( QDomElement & qElement )
{
  return CUMLWidgetData::loadFromXMI( qElement );
}


